{{
*****************************************
* RFM12 Transmitter Demo                *
* Author: Marcello Campione             *
* Copyright (c) 2009                    *
*                                       *
* You may freely use and modify this    *
* programm, but you must keep my name   *
* in the authors list.                  *
*****************************************
}}

CON
    _clkmode = xtal1 + pll16x                           
    _xinfreq = 5_000_000

OBJ
SPI     :       "SPI_Spin1"                              ''The Standalone SPI Spin engine

CON


'Heart Sensor PCB
nSEL    = 25 
SCK     = 26 
SDI     = 27
SDO     = 20

LED     = 14'16
'nIRQ    = 13

{
'Marcellos Protoboard
nSEL    = 11
SCK     = 12
SDI     = 13

SDO     = 14
nIRQ    = 15

LED     = 16
}



WAIT    = 1
NOWAIT  = 0




PUB SPI_DEMO|i


''SPI Setup                      i
  SPI.start(SCK,SDI,SDO,12,0)           ''ClockDelay,ClockState Initialize SPI Engine with Clock Delay of 15us and Clock State of 1
    
      'DirA[nIRQ]:=0
      DirA[LED]:=1
      Outa[LED]:=0

      OutA[nSEL]:=1
      DirA[nSEL]:=1

      'OutA[SDI]:=1
      'DirA[SDI]:=1

      'OutA[SCK]:=0
      'DirA[SCK]:=1

      DirA[SDO]:=0    

    

       waitcnt(cnt+clkfreq/10)    
        

        SendCMD($0000,NOWAIT)
        
        SendCMD($80D7,NOWAIT)            'FIFO & Base Freq  $80D7
         
        SendCMD($8239,NOWAIT)            'Power con clock $8238
       
        SendCMD($A640,NOWAIT)            'Tx Freq. 433,92  $A640

        SendCMD($C628,NOWAIT)            'Data Rate C67f= 2.6kbs      $C628
        
        SendCMD($94C0,NOWAIT)            'Receiver Control Command
                             
        SendCMD($C2AC,NOWAIT)            'Digital Filter, Clock Recovery & DQD Therhold
         
        SendCMD($CA81,NOWAIT)            'FIFO Mode = FIFO Disabled
         
        SendCMD($C493,NOWAIT)            'AFC Config
         
        SendCMD($9820,NOWAIT)            'AFC Freq Deviation 90 Khz, Max Out Power  
         
        SendCMD($E000,NOWAIT)            '
         
        SendCMD($C800,NOWAIT)            '
         
        SendCMD($C000,NOWAIT)            'Battery

         
       
        
              repeat 10
                !Outa[LED]
                waitcnt(cnt+clkfreq/30)

       
      
       repeat

         
         'Outa[LED]:=1
         SendCMD($8239,NOWAIT)            'Power UP con clock $8238
         Outa[LED]:=1
         
         repeat 2
              SendCMD($B8AA,WAIT)      'decimal 170
                             
              
         
         SendCMD($B82D,WAIT)            'TOKEN   45
         SendCMD($B8D4,WAIT)            'TOKEN   212
         
         
         
         
              SendCMD($B810,WAIT)
              SendCMD($B801,WAIT)
              'SendCMD($B810,WAIT)
              'SendCMD($B801,WAIT)
              'SendCMD($B810,WAIT)
              'SendCMD($B801,WAIT)
              
              

         repeat 1
              SendCMD($B8AA,WAIT)      'decimal 170
              
                      
         SendCMD($8201,WAIT)            'Power Down
         Outa[LED]:=0  
         waitcnt(cnt+clkfreq)
      
      
        

 

Pub SendCMD(Command, _Wait)

  'OutA[SCK]:=0
  OutA[nSEL]:=0

     SPI.SHIFTOUT(SDI, SCK, SPI#MSBFIRST , 16, Command)

     if _wait == 1
        repeat while InA[SDO] == 0

  'OutA[SCK]:=0
  OutA[nSEL]:=1


  
      
      
        
        
PUB HIGH(Pin)
    dira[Pin]~~
    outa[Pin]~~
         
PUB LOW(Pin)
    dira[Pin]~~
    outa[Pin]~






{ SAFE CONFIGURATION
        SendCMD($0000,NOWAIT)
        
        SendCMD($80D7,NOWAIT)            'FIFO & Base Freq  $80D7
         
        SendCMD($8239,NOWAIT)            'Power con clock $8238
       
        SendCMD($AF3F,NOWAIT)            'Tx Freq. 433,92  $A640

        SendCMD($C647,NOWAIT)            'Data Rate C67f= 2.6kbs
        
        SendCMD($94C4,NOWAIT)            'Receiver Control Command
                             
        SendCMD($C2AC,NOWAIT)            'Digital Filter, Clock Recovery & DQD Therhold
         
        SendCMD($CA81,NOWAIT)            'FIFO Mode = FIFO Disabled
         
        SendCMD($C493,NOWAIT)            'AFC Config
         
        SendCMD($9827,NOWAIT)            'AFC Freq Deviation 90 Khz, Max Out Power  
         
        SendCMD($E000,NOWAIT)            'AFC
         
        SendCMD($C800,NOWAIT)            'AFC
         
        SendCMD($C000,NOWAIT)            'Battery
         }